# GAN & cGAN tutorial.

Filipe PENNA CERAVOLO SOARES

## Part1: DC-GAN

- In this part, a generative adversarial network (GAN) has been trained to generate new handwritten digits, after feeding it with pictures from the [**MNIST database**](https://en.wikipedia.org/wiki/MNIST_database)
- To do so, the [**DCGAN tutorial**](https://pytorch.org/tutorials/beginner/dcgan_faces_tutorial.html) of pytorch has been followed. This tutorial generate new celebrities after showing it pictures of many real celebrities. 
- To adapt this tutorial to the MNIST database, the most relevant change in its implematation reflects the change of number of channels in the training images (from 3 [*RGB*] to 1 [*Black and White*]).
- The results of the model are satisfying from an academic point of view and really interesting. They and are followed by an analysis of loss during training in the notebook.

**Final output:**

<p align="center">
  <img src="./images/part1-output.png" width="100%">
</p>

## Part2: Conditional GAN (cGAN)

- In this part, a conditional generative adversarial network (cGAN) has been trained to identify if building facades images, from the [**CMP Facade Database**](https://cmp.felk.cvut.cz/~tylecr1/facade/), have generated by a model or are real
- To generate the facade images, a mask, already included in the database, passes through the generator, which delivers as output a believable image. 
- As a final result, the following images were obtained.

**Training set :**

<p align="center">
  <img src="./images/part2-train.png" width="100%">
</p>

**Validation set :**

<p align="center">
  <img src="./images/part2-val.png" width="100%">
</p>

Considering the training set, with a higher number of epochs, the quality of the generated image improves.

Considering the validation set, increasing the number of epochs from 100 to 200 did not let to much improvement. It is important to notice that the lack of improvement in the validation set of a much higher epoch number indicate that model may have already reach its accuracy and it is strating to get overfitted.
